package com.cit.sellfan.ui;

import java.text.NumberFormat;

import com.vaadin.event.FieldEvents.TextChangeEvent;
import com.vaadin.event.FieldEvents.TextChangeListener;
import com.vaadin.ui.Notification;
import com.xdev.ui.XdevTextField;

public class TextFieldInteger extends XdevTextField implements TextChangeListener {
	private final boolean isInteger = true;
	private boolean conSegno = false;
	private String lastValue = "";
	private final NumberFormat fmtNd = NumberFormat.getInstance();

	/**
	 * 
	 */
	public TextFieldInteger() {
		super();
	    setImmediate(true);
	    setTextChangeEventMode(TextChangeEventMode.EAGER);
	    addTextChangeListener(this);
		this.initUI();
		this.fmtNd.setGroupingUsed(false);
	}

	@Override
	public void textChange(final TextChangeEvent event) {
	    final String text = event.getText();
	    try {
	    	if (!text.equals("") && !text.equals("-")) {
	    		if (text.equals("-") && this.conSegno) {
	    			this.lastValue = text;
	    		} else {
	    			if (this.isInteger) {
		    	        new Integer(text);
	    			} else {
				    	final String tmp = text.replaceAll(",", ".");
				        new Double(tmp);
	    			}
			        this.lastValue = text;
	    		}
	    	} else {
	    		if (text.equals("-") && this.conSegno) {
	    			this.lastValue = "-";
	    		} else {
	    			this.lastValue = "";
	    		}
		        
	    	}
	    } catch (final NumberFormatException e) {
	        
	    }
	    setValue(this.lastValue);
	}

	@Override
	public void setValue(final String value) {
		if (value == null || value.equals("") || (value.equals("-") && this.conSegno)) {
			if (value != null) {
				this.lastValue = value;
			} else {
				this.lastValue = "";
			}
		} else {
			try {
				if (this.isInteger) {
					new Integer(value);
				} else {
					final String tmp = value.replaceAll(",", ".");
					new Double(tmp);
				}
				this.lastValue = value;
			}  catch (final NumberFormatException e) {
				Notification.show("setValue String [" + value + "] "+ e.toString());
			}
		}
		super.setValue(this.lastValue);
	}

	public void setConSegno(final boolean value) {
		this.conSegno = value;
	}
	
	public void setMaximumFractionDigits(final int value) {
		this.fmtNd.setMaximumFractionDigits(value);
	}
	
	public void setNumeroDecimali(final int value) {
		this.fmtNd.setMaximumFractionDigits(value);
	}

	public void setValue(final double value) {
		try {
			if (this.isInteger) {
				this.lastValue = Integer.toString((int)value);
			} else {
				this.lastValue = this.fmtNd.format(value);
			}
			super.setValue(this.lastValue);
		} catch (final Exception e) {
			Notification.show("setValue double [" + Double.toString(value) + "] "+ e.toString());
		}
	}
	
	public void setValue(final int value) {
		try {
			this.lastValue = Integer.toString(value);
			super.setValue(this.lastValue);
		} catch (final Exception e) {
			Notification.show("setValue int [" + Integer.toString(value) + "] "+ e.toString());
		}
	}
	
	public double getDoubleValue() {
		if (this.lastValue.equals("") || this.lastValue.equals("-")) {
			return 0.;
		}
		final String tmp = this.lastValue.replaceAll(",", ".");
		return Double.parseDouble(tmp);
	}
	
	public int getIntegerValue() {
		if (this.lastValue.equals("") || this.lastValue.equals("-")) {
			return 0;
		}
		int ret = -1;
		try {
			ret = Integer.parseInt(this.lastValue);
		} catch (final Exception e) {
			
		}
		return ret;
	}
	
	/*
	 * WARNING: Do NOT edit!<br>The content of this method is always regenerated by
	 * the UI designer.
	 */
	// <generated-code name="initUI">
	private void initUI() {
		this.setSizeUndefined();
	} // </generated-code>

}
